<?php

namespace App\Controllers\Admin\Equipment;

use App\Entities\Equipment\ServerEntity;
use App\Services\Equipment\ServerService;
use CodeIgniter\HTTP\RedirectResponse;
use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use Psr\Log\LoggerInterface;

class ServerController extends EquipmentController
{
  public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
  {
    parent::initController($request, $response, $logger);
    $this->content_title = lang("{$this->getService()->getClassName()}.title");
    $this->class_path .= $this->getService()->getClassName();
    $this->uri_path .= strtolower($this->getService()->getClassName('/')) . '/';
    // $this->view_path .= strtolower($this->getService()->getClassName()) . DIRECTORY_SEPARATOR;
  }
  public function getService(): ServerService
  {
    if (!$this->_service) {
      $this->_service = new ServerService();
    }
    return $this->_service;
  }
  //Index,FieldForm관련
  protected function getResultSuccess(string $message = MESSAGES["SUCCESS"], ?string $actionTemplate = null): RedirectResponse|string
  {
    switch ($this->getService()->getAction()) {
      case 'index':
      case 'view':
        $this->service = $this->getService();
        $this->control = $this->getService()->getControlDatas();
        $this->getService()->getHelper()->setViewDatas($this->getViewDatas());
        $actionTemplate = $this->request->getVar('ActionTemplate') ?? $actionTemplate ?? 'server';
        if ($actionTemplate) {
          $view_file = $this->view_path . $actionTemplate . DIRECTORY_SEPARATOR . $this->getService()->getAction();
        } else {
          $view_file = $this->view_path . $this->getService()->getAction();
        }
        $result = view($view_file, ['viewDatas' => $this->getViewDatas()]);
        break;
      default:
        $result = parent::getResultSuccess($message, $actionTemplate);
        break;
    }
    return $result;
  }
  //생성
  protected function create_form_process(): void
  {
    //Form 기본값정의
    $format = env("Server.Prefix.code.format", false);
    if (!$format) {
      throw new \Exception(__METHOD__ . "에서 code의 format[Server.Prefix.code.format]이 정의되지 않았습니다.");
    }
    $this->getService()->setFormDatas([
      'code' => $this->getService()->getLastestCode(
        $format,
        (int)env("Server.Default.code", 0)
      )
    ]);
    parent::create_form_process();
  }
  //생성
  protected function create_process(array $formDatas): ServerEntity
  {
    //코드 패턴체크
    $this->getService()->codeCheck($formDatas);
    return parent::create_process($formDatas);
  }
  //수정
  protected function modify_process(mixed $entity, array $formDatas): ServerEntity
  {
    //코드 패턴체크
    $this->getService()->codeCheck($formDatas);
    return parent::modify_process($entity, $formDatas);
  }
}
